diff --git a/drivers/net/virtio/virtio_ethdev.h b/drivers/net/virtio/virtio_ethdev.h
index 07a9265..f260fbb 100644
--- a/drivers/net/virtio/virtio_ethdev.h
+++ b/drivers/net/virtio/virtio_ethdev.h
@@ -65,7 +65,8 @@
 	 1u << VIRTIO_NET_F_CTRL_RX	  |	\
 	 1u << VIRTIO_NET_F_CTRL_VLAN	  |	\
 	 1u << VIRTIO_NET_F_MRG_RXBUF     |	\
-	 1u << VIRTIO_RING_F_INDIRECT_DESC)
+	 1u << VIRTIO_RING_F_INDIRECT_DESC|	\
+	 1u << VIRTIO_F_ANY_LAYOUT)
 
 /*
  * CQ function prototype
diff --git a/drivers/net/virtio/virtio_rxtx.c b/drivers/net/virtio/virtio_rxtx.c
index 8979695..5ec9b29 100644
--- a/drivers/net/virtio/virtio_rxtx.c
+++ b/drivers/net/virtio/virtio_rxtx.c
@@ -200,13 +200,14 @@ virtqueue_enqueue_recv_refill(struct virtqueue *vq, struct rte_mbuf *cookie)
 
 static int
 virtqueue_enqueue_xmit(struct virtqueue *txvq, struct rte_mbuf *cookie,
-		       int use_indirect)
+		       int use_indirect, int can_push)
 {
 	struct vq_desc_extra *dxp;
 	struct vring_desc *start_dp;
 	uint16_t seg_num = cookie->nb_segs;
-	uint16_t needed = use_indirect ? 1 : 1 + seg_num;
+	uint16_t needed = use_indirect ? 1 : !can_push + seg_num;
 	uint16_t head_idx, idx;
+	uint16_t head_size = txvq->hw->vtnet_hdr_size;
 	unsigned long offs;
 
 	if (unlikely(txvq->vq_free_cnt == 0))
@@ -236,27 +237,31 @@ virtqueue_enqueue_xmit(struct virtqueue *txvq, struct rte_mbuf *cookie,
 		idx = 0;
 	}
 
-	offs = offsetof(struct virtio_tx_region, tx_hdr)
-		+ idx * sizeof(struct virtio_tx_region);
+	if (can_push) {
+		/* put on zero'd transmit header (no offloads) */
+		void *hdr = rte_pktmbuf_prepend(cookie, head_size);
 
-	start_dp[idx].addr = txvq->virtio_net_hdr_mem + offs;
-	start_dp[idx].len = txvq->hw->vtnet_hdr_size;
-	start_dp[idx].flags = VRING_DESC_F_NEXT;
+		memset(hdr, 0, head_size);
+	} else {
+		offs = offsetof(struct virtio_tx_region, tx_hdr)
+			+ idx * sizeof(struct virtio_tx_region);
 
-	for (; ((seg_num > 0) && (cookie != NULL)); seg_num--) {
+		start_dp[idx].addr = txvq->virtio_net_hdr_mem + offs;
+		start_dp[idx].len = head_size;
+		start_dp[idx].flags = VRING_DESC_F_NEXT;
 		idx = start_dp[idx].next;
+	}
+
+	for (; ((seg_num > 0) && (cookie != NULL)); seg_num--) {
 		start_dp[idx].addr  = RTE_MBUF_DATA_DMA_ADDR(cookie);
 		start_dp[idx].len   = cookie->data_len;
-		start_dp[idx].flags = VRING_DESC_F_NEXT;
 		cookie = cookie->next;
+		start_dp[idx].flags = cookie ? VRING_DESC_F_NEXT : 0;
+		idx = start_dp[idx].next;
 	}
 
-	start_dp[idx].flags &= ~VRING_DESC_F_NEXT;
-
 	if (use_indirect)
 		idx = txvq->vq_ring.desc[head_idx].next;
-	else
-		idx = start_dp[idx].next;
 
 	txvq->vq_desc_head_idx = idx;
 	if (txvq->vq_desc_head_idx == VQ_RING_DESC_CHAIN_END)
@@ -762,6 +767,26 @@ virtio_recv_mergeable_pkts(void *rx_queue,
 	return nb_rx;
 }
 
+/* Evaluate whether the virtio header can just be put in place in the mbuf */
+static int virtio_xmit_push_ok(const struct virtqueue *txvq,
+			       const struct rte_mbuf *m)
+{
+	if (rte_mbuf_refcnt_read(m) != 1)
+		return 0;	/* no mbuf is shared */
+
+	if (rte_pktmbuf_headroom(m) < txvq->hw->vtnet_hdr_size)
+		return 0;	/* no space in headroom */
+
+	if (!rte_is_aligned(rte_pktmbuf_mtod(m, char *),
+			    sizeof(struct virtio_net_hdr_mrg_rxbuf)))
+		return 0;	/* not alligned */
+
+	if (m->nb_segs > 1)
+		return 0;	/* better off using indirect */
+
+	return vtpci_with_feature(txvq->hw, VIRTIO_F_ANY_LAYOUT);
+}
+
 uint16_t
 virtio_xmit_pkts(void *tx_queue, struct rte_mbuf **tx_pkts, uint16_t nb_pkts)
 {
@@ -781,14 +806,16 @@ virtio_xmit_pkts(void *tx_queue, struct rte_mbuf **tx_pkts, uint16_t nb_pkts)
 
 	for (nb_tx = 0; nb_tx < nb_pkts; nb_tx++) {
 		struct rte_mbuf *txm = tx_pkts[nb_tx];
-		int use_indirect, slots, need;
-
-		use_indirect = vtpci_with_feature(txvq->hw,
-						  VIRTIO_RING_F_INDIRECT_DESC)
-			&& (txm->nb_segs < VIRTIO_MAX_TX_INDIRECT);
+		int use_indirect = 0, slots, need;
+		int can_push = virtio_xmit_push_ok(txvq, txm);
+		
+		if (!can_push &&
+		    txm->nb_segs < VIRTIO_MAX_TX_INDIRECT &&
+		    vtpci_with_feature(txvq->hw, VIRTIO_RING_F_INDIRECT_DESC))
+			use_indirect = 1;
 
 		/* How many ring entries are needed to this Tx? */
-		slots = use_indirect ? 1 : 1 + txm->nb_segs;
+		slots = use_indirect ? 1 : !can_push + txm->nb_segs;
 		need = slots - txvq->vq_free_cnt;
 
 		/* Positive value indicates it need free vring descriptors */
@@ -816,7 +843,7 @@ virtio_xmit_pkts(void *tx_queue, struct rte_mbuf **tx_pkts, uint16_t nb_pkts)
 		}
 
 		/* Enqueue Packet buffers */
-		error = virtqueue_enqueue_xmit(txvq, txm, use_indirect);
+		error = virtqueue_enqueue_xmit(txvq, txm, use_indirect, can_push);
 		if (unlikely(error)) {
 			if (error == ENOSPC)
 				PMD_TX_LOG(ERR, "virtqueue_enqueue Free count = 0");